import pandas, re, argparse, sys
import numpy as np

def numeric_value(s):
    m = re.findall(r'.*?_(\d+)', s)
    return int(m[0]) if m else 0

def get_percentages(i, o, p1, p2, has_rn, no_cr):

    hmp= pandas.read_table(i, na_values=['N','NA'])

    if has_rn == True and no_cr == False:
        hmp=hmp.drop(['rs#','chrom','pos','alleles','read_num','marker_call_rate'], axis=1)

    elif has_rn == False and no_cr == False:
       hmp=hmp.drop(['rs#','chrom','pos','alleles', 'marker_call_rate'],axis=1)

    elif has_rn == True and no_cr == True:
        hmp=hmp.drop(['rs#','chrom','pos','alleles', 'read_num'], axis=1)

    else:
        hmp= hmp.drop(['rs#','chrom','pos','alleles'],axis=1)


    #calculate alelle percentages
    dict_a={}
    dict_b={}
    dict_h={}
    dict_n={}
    a_counter=0
    b_counter=0
    h_counter=0
    n_counter=0
    
    for col_idx, col in hmp.iteritems():
        
        for row_idx, row in col.iteritems():
            A= hmp.ix[row_idx, p1]
            B= hmp.ix[row_idx, p2]

            if row == A:
                a_counter += 1
            elif row == B:
                b_counter += 1
            elif pandas.isnull(row):
                n_counter += 1
            else:
                h_counter += 1

        notnull= a_counter+b_counter+h_counter
        dict_a[col_idx]= (a_counter/notnull)*100
        dict_b[col_idx]= (b_counter/notnull)*100
        dict_h[col_idx]= (h_counter/notnull)*100
        dict_n[col_idx]= (n_counter/len(hmp))*100

        a_counter=0
        b_counter=0
        h_counter=0
        n_counter=0
        

        
        
     #concat series into one hapmap

    stats=[dict_a, dict_b, dict_h, dict_n]
    out= pandas.DataFrame(stats, index=[('%_'+p1),('%_'+p2), '%_het', '%_missing'])
    outT=out.T
    outT=outT.reindex(index= sorted(outT.index, key=numeric_value))
    outT.to_csv(o, sep='\t')

def main():

    parser= argparse.ArgumentParser(description="PLUMAGE v. 2.0: pipeline for GBS error correction")

    parser.add_argument('-i', metavar= 'infile', nargs='?', type= argparse.FileType('r'), default= sys.stdin,
                        help= "path/name for file you want genome percentages for, default = stdin")

    parser.add_argument('-o', metavar= 'outfile', type= argparse.FileType('w'), nargs='?', default= sys.stdout,
                        help= "path/name for resulting percentages file, default= stdout")

    parser.add_argument('-p1', metavar= 'parent_1', required= True,
                        help= "exact name of parent 1 as it is in your files")

    parser.add_argument('-p2', metavar= 'parent 2', required=True,
                        help= "exact name of parent 2 as it is in your files")

    parser.add_argument('--has_rn', action= 'store_true',
                        help= "flag presence indicates that the infile has a column containing read number")

    parser.add_argument('--no_cr', action= 'store_true', 
                        help= "flag presence indicates infile has no column for call rates")


    args = parser.parse_args()
    get_percentages(args.i, args.o, args.p1, args.p2, args.has_rn, args.no_cr)

    print("Plumage 8 is finished", file=sys.stderr)

if __name__ == "__main__":
  main()


